# ebestmk

ebestmk is a full text search indexer for EPWING dictionaries using Hyper Estraier.

## Requirement
### [QDBM](https://dbmx.net/qdbm/)
Using [modified version (by me)](https://github.com/ikazuhiro/qdbm/) is recommended.
It fixes the optimization issue and so on.

### [Hyper Estraier](https://dbmx.net/hyperestraier)
Using [modified version (by me)](https://github.com/ikazuhiro/hyperestraier-encore/) is recommended.
It fixes some problems for large index.

### [EB Library with UTF-8 support](http://green.ribbon.to/~ikazuhiro/dic/ebu.html)
Orginal EB Library is not supported.

## Build
You can build program with ordinary procedure for packages using autotools.

```shell
$ ./configure && make
```

## Usage
### Build index
#### Preparation
Place [Gaiji Unicde Map](http://ebstudio.info/manual/EBWin4_man/0_4_5.html) file (*.map) to the root directory of the dictionary if you have.  Replaced unicode characters will be indexed and searchable.

```
$ ls -la
total 148
drwxrwx---+ 1 user users      0 Apr  3 22:57 .
drwxrwx---+ 1 user users      0 Jul 27  2021 ..
-rwxrwx---+ 1 user users   2048 Dec 19  2007 CATALOGS
drwxrwx---+ 1 user users      0 Jan 23  2016 FUROKU
drwxrwx---+ 1 user users      0 Jan 23  2016 KOJIEN
-rwxrwx---+ 1 user users 126880 Sep  7  2007 KOJIEN.map
```

#### Run ebestmk
Run `ebestmk` program with dictionary's directory.

```
$ ebestmk .
```

There are some options to control ebestmk, please confirm via `-h` option.

```
$ ebestmk -h
```

`_ebest` directory should be made in the dictionary's root directory.
It is Hyper Estraier's index and you can search from it by `estcmd` program.

```
$ ls -la
total 152
drwxrwx---+ 1 user users      0 Apr  3 22:57 .
drwxrwx---+ 1 user users      0 Jul 27  2021 ..
-rwxrwx---+ 1 user users   2048 Dec 19  2007 CATALOGS
drwxrwx---+ 1 user users      0 Jan 23  2016 FUROKU
drwxrwx---+ 1 user users      0 Jan 23  2016 KOJIEN
-rwxrwx---+ 1 user users 126880 Sep  7  2007 KOJIEN.map
drwxrwx---+ 1 user users      0 Apr  3 22:59 _ebest
```

### Search index
#### By Lookup
Recent [lookup-1.4+media](http://green.ribbon.to/~ikazuhiro/lookup/lookup.html) supports ebestmk's index.

#### By estcmd
You can use estcmd for searching.

```
estcmd search -vh _ebest phrase
```

If you want to search entry from spefcified subbok, add attribute filter.

```
estcmd search -vh -attr '@uri STRBW eb:subbookname/' _ebest phrase
```

Available subbook names are listed by below commands.

```
$ estcmd search -vf -attr '@uri STRBW ebest:subinfo/' _ebest [UVSET]
```
or
```
$ estcmd search -vf -attr 'eblook_code NUMGE 0' _ebest [UVSET]
```

```
--------[02D18ACF722F7AFB]--------
VERSION 1.0
NODE    local
HIT     2
HINT#1  [UVSET] 225533
TIME    0.338000
DOCNUM  225533
WORDNUM 488977
VIEW    FULL

--------[02D18ACF722F7AFB]--------
@digest=2960c18c0d5393f72583302a57f38ac2
@id=225529
@title=ebest subbook information
@uri=ebest:subinfo/furoku
eblook_code=2

2. furoku
--------[02D18ACF722F7AFB]--------
@digest=d1343aca94c439215c63d21d15ced469
@id=1
@title=ebest subbook information
@uri=ebest:subinfo/kojien
eblook_code=1

1. kojien
--------[02D18ACF722F7AFB]--------:END
```

## License
[GPL2](https://www.gnu.org/licenses/old-licenses/gpl-2.0.html)
